package cz.vsb.fei.efrei.lab04;

import java.util.LinkedList;
import java.util.List;

public class Country<T extends Fighter> {

	private List<T> army;

	private String name;

	public Country(String name) {
		this.name = name;
		army = new LinkedList<>();
	}

	public String getName() {
		return name;
	}

	public void hire(T soldier) {
		army.add(soldier);
	}

	public int getArmyStrength() {
		int sum = 0;
		for (T t : army) {
			if(t.isAlive()) {
				sum += t.getStrenght();
			}
		}
		return sum;
	}

	public int getAliveSoldierCount() {
		int count = 0;
		for (T t : army) {
			if(t.isAlive()) {
				count++;
			}
		}
		return count;
	}

	public int getSoldierAverageStrength() {
		int sum = getArmyStrength();
		int count =getAliveSoldierCount();
		if(count == 0) {
			return 0;
		}
		return sum/count;
	}

	public List<? extends Fighter> getArmy() {
		return army;
	}
	
	public String getArmyStat() {
		return String.format("%6d[%3d] - %5d", getArmyStrength(), getSoldierAverageStrength(), getAliveSoldierCount());
	}
	
	public boolean someoneAlive() {
		for (T t : army) {
			if(t.isAlive()) {
				return true;
			}
		}
		return false;
	}
}
