package cz.vsb.fei.efrei.lab04;

import java.util.Random;

public class Hero implements Fighter {

	private static final Random RANDOM = new Random();

	@Order(2)
	@Formatter(length = 15)
	protected String name;
	@Order(3)
	@Formatter(length = 5)
	protected int strenght;
	@Order(1)
	@Formatter(length = 4, name = "LIVES")
	private int lives;

	public Hero(String name, int strenght) {
		if (name == null || name.length() < 2 || strenght < 30) {
			throw new IllegalArgumentException("Sorry wrong arguments!!");
		}
		this.name = name;
		this.strenght = strenght;
		this.lives = 100;
	}

	public Hero(String name) {
		this(name, RANDOM.nextInt(60) + 50);
	}

	@Override
	public void attackedBy(Fighter fighter) throws AlreadyDeadException {
		if (!isAlive()) {
			throw new AlreadyDeadException(this);
		}
//		System.out.println(fighter.getName() + " attack " + getName() + "!");
		if (RANDOM.nextBoolean()) {
//			System.out.println("Attack was blocked!! Ha. Ha. Ha.");
			return;
		}
		lives -= fighter.getStrenght();
	}

	@Override
	public String getName() {
		return name;
	}

	@Override
	public int getStrenght() {
		return strenght;
	}

	@Override
	public int getLives() {
		return lives;
	}

	@Override
	public String toString() {
		return String.format("Hero    %20s (%4d) - has %4d lives.", name, strenght, lives);
	}

	@Override
	public int compareTo(Fighter o) {
		return this.getName().compareTo(o.getName());
	}

}
