package cz.vsb.fei.efrei.lab04;

import java.util.Random;

public class ParralerWorld {

	private char[] text;
	private boolean stop;
	private Object bounceMonitor = new Object();
	private int bouncePosition = 10;

	public static void main(String[] args) {
		new ParralerWorld().animation();
	}

	public static void printOuptup() {
		Object monitor = new Object();
		for (int i = 0; i < 5; i++) {
			Thread t = new Thread(() -> {
				Random random = new Random();
				for (int j = 0; j < 100 && !Thread.currentThread().isInterrupted(); j++) {
					synchronized (monitor) {
						for (int k = 0; k < 5; k++) {
							System.out.println(
									((j * 5) + k) + ": Hello from thread: " + Thread.currentThread().getName());
						}
					}
//					try {
//						Thread.sleep(random.nextInt(1000, 5000));
//					} catch (InterruptedException e) {
//						Thread.currentThread().interrupt();
//					}
				}
			});
			t.setName("My super Thrtead " + i);
			t.start();
		}

	}

	private void animation() {
		Thread t1 = new Thread(this::draw);
		t1.start();
		new Thread(() -> rotatingBackslash(100)).start();
		new Thread(() -> rotatingBackslash(500)).start();
		new Thread(() -> move(200, 'o', 1)).start();
		new Thread(() -> move(200, '*', 18)).start();
	}

	private void draw() {
		text = new char[20];
		for (int i = 0; i < text.length; i++) {
			text[i] = '_';
		}
		while (!stop && !Thread.currentThread().isInterrupted()) {
			for (int i = 0; i < text.length; i++) {
				if (text[i] == '_') {
					text[i] = '‾';
				} else if (text[i] == '‾') {
					text[i] = '_';
				}
			}
			System.out.print(new String(text));
			System.out.print("\r");
			try {
				Thread.sleep(1);
			} catch (InterruptedException e) {
				Thread.currentThread().interrupt();
			}
		}
	}

	private void rotatingBackslash(int delay) {
		char[] backslash = new char[] { '\\', '/', '—' };
		int index = new Random().nextInt(text.length);
		while (!stop && !Thread.currentThread().isInterrupted()) {
			for (int i = 0; i < backslash.length; i++) {
				text[index] = backslash[i];
				try {
					Thread.sleep(delay);
				} catch (InterruptedException e) {
					Thread.currentThread().interrupt();
					break;
				}
			}
		}
	}

	private void move(int delay, char character, int index) {
//		int index = new Random().nextInt(text.length);
		int direction = 1;
		int oldIndex = index;
		synchronized (bounceMonitor) {
			while (!stop && !Thread.currentThread().isInterrupted()) {
				text[oldIndex] = '_';
				text[index] = character;
				oldIndex = index;
				index += direction;
				if (index == 0 || index == text.length - 1 || index == bouncePosition) {
					direction = -direction;
				}
				if(index == bouncePosition) {
					try {
						bounceMonitor.notifyAll();
						bounceMonitor.wait();
					} catch (InterruptedException e) {
						Thread.currentThread().interrupt();
						continue;
					}
				}
				try {
					Thread.sleep(delay);
				} catch (InterruptedException e) {
					Thread.currentThread().interrupt();
					break;
				}
			}
		}
	}
}
